searchData={"items":[{"type":"module","title":"EasyRpc","doc":"EasyRpc is a library help Elixir developer can work easily in Elixir cluster.\nPlease go to README for more information.","ref":"EasyRpc.html"},{"type":"module","title":"EasyRpc.DefRpc","doc":"This is second way to add a rpc to local module.\nIn this way, you need declare all rpc functions in a module.\nConfigs for nodes (list of node or {Module, :function, args}) can put to config.exs for runtime.exs file.","ref":"EasyRpc.DefRpc.html"},{"type":"module","title":"GUIDE - EasyRpc.DefRpc","doc":"","ref":"EasyRpc.DefRpc.html#module-guide"},{"type":"module","title":"Add config for DefRpc - EasyRpc.DefRpc","doc":"Add config to config file in your project.\n\n```Elixir\nconfig :simple_example, :remote_defrpc,\n  nodes: [:\"remote@127.0.0.1\"],  # or using {module, function, args} like: {ClusterHelper, :get_nodes, [:remote_api]},\n  select_mode: :round_robin # default is :random\n  sticky_node: true # default is false\n```\n\nExplain config:\n\n`:nodes` List of nodes, or {module, function, args} on local node.\n\n`:select_mode` Select node mode, default is :random. Support for  [:random, :round_robin, :hash].\n  :round_robin will use per process to select node.\n  :hash will using :erlang.phash2 to select node in list, data is arguments of function.\n\n`:sticky_node` If set to true, the node will be sticky for each call. Default is false.\n\nNote: `sticky_node` & `round_robin` are supported for rpc per process only.","ref":"EasyRpc.DefRpc.html#module-add-config-for-defrpc"},{"type":"module","title":"Using DefRpc in your module - EasyRpc.DefRpc","doc":"Add your global config for function & config info.\n\n```Elixir\n  use EasyRpc.DefRpc,\n    otp_app: :simple_example,\n    config_name: :remote_defrpc,\n    # Remote module name\n    module: RemoteNode.Interface,\n    timeout: 1000,\n    retry: 0\n```\n\nExplain:\n\n`:otp_app` Application name for config.\n\n`:config_name` Config name for rpc.\n\n`:module` Remote module name.\n\n`:timeout` Timeout for rpc, default for all functions. If set timeout for function, it will override this value.\n\n`:retry` Retry times for rpc, default for all functions. If set retry for function, it will override this value.\n\n`:error_handling` Enable error handling (catch all) or not. In case of retry > 0, error_handling will be always true.","ref":"EasyRpc.DefRpc.html#module-using-defrpc-in-your-module"},{"type":"module","title":"Define rpc functions - EasyRpc.DefRpc","doc":"```Elixir\ndefrpc :get_data\ndefrpc :put_data, args: 1\ndefrpc :clear, args: 2, as: :clear_data, private: true\ndefrpc :put_data, args: [:name], new_name: :put_with_retry, retry: 3, timeout: 1000\n```\n\nExplain:\n\n`:args` Number of arguments for function. If set to 0 or missed, function will be defined without arguments.\n\n`:as` New name for function. If set, function will be defined with new name.\n\n`:private` If set to true, the function will be defined as private function. Default is false (public function).\n\n`:retry` Retry times for rpc, default for all functions. If set retry for function, it will override this value.\n\n`:timeout` Timeout for rpc, default for all functions. If set timeout for function, it will override this value.\n\n`:error_handling` Enable error handling (catch all) or not. In case of retry > 0, error_handling will be always true.","ref":"EasyRpc.DefRpc.html#module-define-rpc-functions"},{"type":"macro","title":"EasyRpc.DefRpc.defrpc/2","doc":"","ref":"EasyRpc.DefRpc.html#defrpc/2"},{"type":"module","title":"EasyRpc.RpcWrapper","doc":"This module provides a wrapper for RPC (Remote Procedure Call) in Elixir.\nIt helps to call remote functions as local functions.\nThe library uses macro to create a local function (declare by config).\n\nCurrently, the you can wrapping multiple remote functions in a module.\nYou can use same name or different name for remote functions.\nYou also can have multiple wrappers for multiple remote modules.\n\nThis solution for put all most things to config.exs file.\nNode list is fixed list but you can use {module, function, args} to get nodes dynamically.","ref":"EasyRpc.RpcWrapper.html"},{"type":"module","title":"Guide - EasyRpc.RpcWrapper","doc":"","ref":"EasyRpc.RpcWrapper.html#module-guide"},{"type":"module","title":"Add config for RpcWrapper - EasyRpc.RpcWrapper","doc":"Put config to config.exs file in your project.\nFor multi wrapper, you need to separate configs for each wrapper.\n\nExample:\n\n```Elixir\nconfig :app_name, :wrapper_name,\n  nodes: [:\"test1@test.local\", :\"test2@test.local\"],\n  # or nodes: {MyModule, :get_nodes, []}\n  error_handling: true, # enable error handling, global setting for all functions.\n  select_mode: :random, # select node mode, global setting for all functions.\n  sticky_node: false, # sticky node, global setting for all functions.\n  timeout: 3_000, # timeout(ms) for each call, global setting for all functions, default is 5000ms.\n  module: TargetApp.RemoteModule,\n  functions: [\n    # {function_name, arity, options \\ []}\n    {:get_data, 1},\n    {:put_data, 1, error_handling: false},\n    {:clear, 2, [new_name: :clear_data, private: true]},\n    {:put_data, 1, [new_name: :put_with_retry, retry: 3, timeout: 1_000]}\n  ]\n```\n\nExplain config:\n\n`:nodes` List of nodes, or {module, function, args} on local node.\n\n`:module` Module of remote functions on remote node.\n\n`:error_handling` Enable error handling (catch all) or not.\n\n`:select_mode` Select node mode, support for random, round_robin, hash.\n\n`:timeout` Timeout for rpc, default for all functions. If set timeout for function, it will override this value.\n\n`:functions` List of functions, each function is a tuple {function_name, arity} or {function_name, new_name, arity, opts}.\n\n`:options` Keyword of options, including new_name, retry, error_handling. Ex: [new_name: :clear_data, retry: 0, error_handling: true, timeout: 1_000].\nIf retry is set, the function will retry n times when error occurs and error_handling will be applied.\nIf error_handling is set, the function will catch all exceptions and return {:error, reason}.\n\n`:private` If set to true, the function will be defined as private function. Default is false (public function).\n\nNote: `:sticky_node` & `:round_robin` are supported for rpc per process only.","ref":"EasyRpc.RpcWrapper.html#module-add-config-for-rpcwrapper"},{"type":"module","title":"RpcWrapper - EasyRpc.RpcWrapper","doc":"Usage:\n\nby using RpcWrapper in your module, you can call remote functions as local functions.\n\nExample:\n\n```Elixir\ndefmodule DataHelper do\nuse EasyRpc.RpcWrapper,\n  otp_app: :app_name,\n  config_name: :wrapper_name\n\ndef process_remote() do\n  case get_data(\"key\") do\n    {:ok, data} ->\n      # do something with data\n    {:error, reason} ->\n      # handle error\n  end\nend\n```\n\nExplain:\n`:otp_app`, name of application will add config.\n`:config_name`, name of config in application config.","ref":"EasyRpc.RpcWrapper.html#module-rpcwrapper"},{"type":"exception","title":"EasyRpc.ConfigError","doc":"","ref":"EasyRpc.ConfigError.html"},{"type":"function","title":"EasyRpc.ConfigError.log_error/1","doc":"","ref":"EasyRpc.ConfigError.html#log_error/1"},{"type":"function","title":"EasyRpc.ConfigError.print/1","doc":"","ref":"EasyRpc.ConfigError.html#print/1"},{"type":"function","title":"EasyRpc.ConfigError.raise_error/1","doc":"","ref":"EasyRpc.ConfigError.html#raise_error/1"},{"type":"exception","title":"EasyRpc.RpcError","doc":"","ref":"EasyRpc.RpcError.html"},{"type":"function","title":"EasyRpc.RpcError.log_error/1","doc":"","ref":"EasyRpc.RpcError.html#log_error/1"},{"type":"function","title":"EasyRpc.RpcError.print/1","doc":"","ref":"EasyRpc.RpcError.html#print/1"},{"type":"function","title":"EasyRpc.RpcError.raise_error/1","doc":"","ref":"EasyRpc.RpcError.html#raise_error/1"},{"type":"extras","title":"Readme","doc":"[![Docs](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/easy_rpc)\n[![Hex.pm](https://img.shields.io/hexpm/v/easy_rpc.svg?style=flat&color=blue)](https://hex.pm/packages/easy_rpc)\n\n# EasyRpc\n\nThis library help developer easy to wrap a remote procedure call (rpc, library uses Erlang `:erpc` module) to local function.\n\nEasyRpc supports some basic features for wrapping rpc: retry, timeout, error_handling.\nEach function can has seperated options or use global options (in a module).\n\nCan use EasyRpc with [ClusterHelper](https://hex.pm/packages/cluster_helper) for calling a rpc in a dynamic Elixir cluster.","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"Adding `easy_rpc` library to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:easy_rpc, \"~> 0.4.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - defrpc way - Readme","doc":"In this way, you need to add config for node list & its select_mode.\nThe config can add in compile time or runtime or using {module, function arguments} for selecting by function.\n\nFor wrapping a remote function to local module you need to use macro `defrpc`.","ref":"readme.html#usage-defrpc-way"},{"type":"extras","title":"Add Configs - Readme","doc":"```Elixir\nconfig :simple_example, :remote_defrpc,\n  nodes: [:\"remote@127.0.0.1\"],  # or {ClusterHelper, :get_nodes, [:remote_api]},\n  select_mode: :round_robin,\n  sticky_node: true\n```\n\nCurrent version, `:round_robin` & `:sticky_node` are worked for process only.","ref":"readme.html#add-configs"},{"type":"extras","title":"Declare functions - Readme","doc":"```Elixir\ndefmodule Remote\n  use EasyRpc.DefRpc,\n    otp_app: :simple_example,\n    config_name: :remote_defrpc,\n    # Remote module name\n    module: RemoteNode.Interface,\n    timeout: 1000\n\n  defrpc :get_data\n  defrpc :put_data, args: 1\n  defrpc :clear, args: 2, as: :clear_data, private: true\n  defrpc :put_data, args: [:name], new_name: :put_with_retry, retry: 3, timeout: 1000\nend\n```","ref":"readme.html#declare-functions"},{"type":"extras","title":"Usage - Config way - Readme","doc":"This is an example for declare by config in config.exs file.\nAll function & node info (excepted `nodes: {module, function, arguments}`) are generated at compile time.\nFor this way you need to work with config than module.\n\nFollow steps","ref":"readme.html#usage-config-way"},{"type":"extras","title":"Add config to config.exs - Readme","doc":"Put config to config.exs file, and use it in your module by using RpcWrapper.\nUser need separate config for each wrapper, and put it in config.exs\n\n```Elixir\nconfig :app_name, :wrapper_name,\n  nodes: [:\"test1@test.local\"], # or using function like nodes: {Module, Fun, Args}\n  error_handling: true,\n  select_mode: :random,\n  module: TargetApp.Interface.Api,\n  functions: [\n    # {function_name, arity, options}\n    {:get_data, 1},\n    {:put_data, 1, error_handling: false},\n    {:clear, 2, new_name: :clear_data, retry: 3},\n    {:clear_all, 0, new_name: :clear_all, private: true}, # wrap to private function.\n  ]\n```","ref":"readme.html#add-config-to-config-exs"},{"type":"extras","title":"Wrap to local module - Readme","doc":"by using `use EasyRpc.RpcWrapper` in your module, you can call remote functions as local functions.\n\n```Elixir\ndefmodule DataHelper do\n  use EasyRpc.RpcWrapper,\n    otp_app: :app_name,\n    config_name: :account_wrapper\n\n  def process_remote() do\n    # call rpc like a local function.\n    case get_data(\"key\") do\n      {:ok, data} ->\n        # do something with data\n\n      {:error, reason} ->\n        # handle error\n    end\n  end\nend\n\n# Or call from other module like\n{:ok, result} = DataHelper.get_data(\"my_key\")\n```\n\nFor more details please go to module's docs.","ref":"readme.html#wrap-to-local-module"},{"type":"extras","title":"Example - Readme","doc":"You can go to example folder to see how EasyRpc work, check config & run and see.\n\nGo to [lib_examples on Github](https://github.com/ohhi-vn/lib_examples/tree/main/easy_rpc) and follow the README in sub folders.","ref":"readme.html#example"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}